local ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua');
local ScenarioFramework = import('/lua/ScenarioFramework.lua');
local Utilities = import('/lua/utilities.lua');
local Entity = import('/lua/sim/Entity.lua').Entity;



local bp = GetUnitBlueprintByName("urc1901")
bp.Intel.VisionRadius = 290
bp.Economy.BuildTime = 800

function OnPopulate()
	ScenarioUtils.InitializeArmies()
    if (ScenarioInfo.Options.opt_tents == nil) then
		ScenarioInfo.Options.opt_tents = 0;
	end
    if (ScenarioInfo.Options.opt_transcount == nil) then
		ScenarioInfo.Options.opt_transcount = 0;
	end
	if (ScenarioInfo.Options.opt_timeunlocked == nil) then
		ScenarioInfo.Options.opt_timeunlocked = 0;
	end
	if (ScenarioInfo.Options.opt_gamemode == nil) then
		ScenarioInfo.Options.opt_gamemode = 0;
	end
	

transportscoutonly()	
spawntents()
spawnlighthouse()
unlockovertime()
createmiddleciv()
end

function OnStart(self) 
end



--checks for army existance
armyexist = function(testarmy) 
local army_list = ListArmies();
for key, value in army_list do 
    if (value == testarmy) then
     return true;
    end
  end
end

--spawns the civilian lighthouse
spawnlighthouse = function()
    local light1 = CreateUnitHPR( "urc1901", "NEUTRAL_CIVILIAN", 13.816323, 25.730654, 500.078125, 0,0,0)
    local light2 = CreateUnitHPR( "urc1901", "NEUTRAL_CIVILIAN", 498.060150, 25.724628, 12.122614, 0,0,0)
    light1:SetReclaimable(false);
    light1:SetCanTakeDamage(false);
    light2:SetReclaimable(false);
    light2:SetCanTakeDamage(false);
	
	light1.OldOnCaptured = light1.OnCaptured;
	light1.OnCaptured = function(self, captor)	
		local newunit = ChangeUnitArmy(self,captor:GetArmy())
		newunit:SetReclaimable(false);
		newunit:SetCanTakeDamage(false);
	end
		
	light2.OldOnCaptured = light2.OnCaptured;
	light2.OnCaptured = function(self, captor)	
		local newunit = ChangeUnitArmy(self,captor:GetArmy())
		newunit:SetReclaimable(false);
		newunit:SetCanTakeDamage(false);
	end
		
end

--spawns tents, checks if army exists before inserting, otherwise
spawntents = function()
local tent = "xrb0304"
if (ScenarioInfo.Options.opt_tents == 1) then
  if(armyexist("ARMY_1") == true) then
	CreateUnitHPR( tent, "ARMY_1", 309.500000, 25.984375, 445.500000, 0,0,0)
  end
  if(armyexist("ARMY_2") == true) then
	CreateUnitHPR( tent, "ARMY_2", 371.500000, 25.984375, 429.500000, 0,0,0)
  end
  if(armyexist("ARMY_3") == true) then
	CreateUnitHPR( tent, "ARMY_3", 431.500000, 25.984375, 369.500000, 0,0,0)
  end  
  if(armyexist("ARMY_4") == true) then	
    CreateUnitHPR( tent, "ARMY_4", 447.500000, 25.984375, 315.500000, 0,0,0)
  end
  if(armyexist("ARMY_5") == true) then	
    CreateUnitHPR( tent, "ARMY_5", 202.500000, 25.984375, 70.500000 , 0,0,0)
  end
  if(armyexist("ARMY_6") == true) then	
    CreateUnitHPR( tent, "ARMY_6", 136.500000, 25.992188, 81.500000  , 0,0,0)
  end  
  if(armyexist("ARMY_7") == true) then	
    CreateUnitHPR( tent, "ARMY_7", 75.500000, 25.992188, 142.500000  , 0,0,0)
  end
  if(armyexist("ARMY_8") == true) then
	CreateUnitHPR( tent, "ARMY_8", 64.500000, 25.984375, 200.500000 , 0,0,0)
  end
end
		
if (ScenarioInfo.Options.opt_tents == 2) then
  if(armyexist("ARMY_1") == true) then
	CreateUnitHPR( tent, "ARMY_1", 309.500000, 25.984375, 445.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_1", 309.500000, 25.984375, 443.500000, 0,0,0)
  end
  if(armyexist("ARMY_2") == true) then
	CreateUnitHPR( tent, "ARMY_2", 371.500000, 25.984375, 429.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_2", 371.500000, 25.984375, 427.500000, 0,0,0)
  end
  if(armyexist("ARMY_3") == true) then	
	CreateUnitHPR( tent, "ARMY_3", 431.500000, 25.984375, 367.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_3", 431.500000, 25.984375, 369.500000, 0,0,0)
  end
  if(armyexist("ARMY_4") == true) then	
	CreateUnitHPR( tent, "ARMY_4", 447.500000, 25.984375, 315.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_4", 447.500000, 25.984375, 313.500000, 0,0,0)
  end
  if(armyexist("ARMY_5") == true) then	
	CreateUnitHPR( tent, "ARMY_5", 202.500000, 25.984375, 70.500000 , 0,0,0)
	CreateUnitHPR( tent, "ARMY_5", 202.500000, 25.984375, 68.500000 , 0,0,0)
  end
  if(armyexist("ARMY_6") == true) then
	CreateUnitHPR( tent, "ARMY_6", 136.500000, 25.992188, 81.500000  , 0,0,0)
	CreateUnitHPR( tent, "ARMY_6", 136.500000, 25.992188, 79.500000  , 0,0,0)
  end
  if(armyexist("ARMY_7") == true) then
	CreateUnitHPR( tent, "ARMY_7", 75.500000, 25.992188, 142.500000  , 0,0,0)
	CreateUnitHPR( tent, "ARMY_7", 75.500000, 25.992188, 140.500000  , 0,0,0) 
  end
  if(armyexist("ARMY_8") == true) then
	CreateUnitHPR( tent, "ARMY_8", 64.500000, 25.984375, 200.500000 , 0,0,0)
	CreateUnitHPR( tent, "ARMY_8", 64.500000, 25.984375, 198.500000 , 0,0,0)
  end
end
	
if (ScenarioInfo.Options.opt_tents == 3) then
  if(armyexist("ARMY_1") == true) then
	CreateUnitHPR( tent, "ARMY_1", 309.500000, 25.984375, 445.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_1", 309.500000, 25.984375, 443.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_1", 309.500000, 25.984375, 441.500000, 0,0,0) 
  end
  if(armyexist("ARMY_2") == true) then
	CreateUnitHPR( tent, "ARMY_2", 371.500000, 25.984375, 429.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_2", 371.500000, 25.984375, 427.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_2", 371.500000, 25.984375, 425.500000, 0,0,0) 
  end
  if(armyexist("ARMY_3") == true) then
	CreateUnitHPR( tent, "ARMY_3", 431.500000, 25.984375, 367.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_3", 431.500000, 25.984375, 369.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_3", 431.500000, 25.984375, 365.500000, 0,0,0)
  end
  if(armyexist("ARMY_4") == true) then
	CreateUnitHPR( tent, "ARMY_4", 447.500000, 25.984375, 315.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_4", 447.500000, 25.984375, 313.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_4", 447.500000, 25.984375, 311.500000, 0,0,0)
  end
  if(armyexist("ARMY_5") == true) then
	CreateUnitHPR( tent, "ARMY_5", 202.500000, 25.984375, 70.500000 , 0,0,0)
	CreateUnitHPR( tent, "ARMY_5", 202.500000, 25.984375, 68.500000 , 0,0,0)
	CreateUnitHPR( tent, "ARMY_5", 202.500000, 25.984375, 66.500000 , 0,0,0) 
  end
  if(armyexist("ARMY_6") == true) then
	CreateUnitHPR( tent, "ARMY_6", 136.500000, 25.992188, 81.500000  , 0,0,0)
	CreateUnitHPR( tent, "ARMY_6", 136.500000, 25.992188, 79.500000  , 0,0,0)
	CreateUnitHPR( tent, "ARMY_6", 136.500000, 25.992188, 77.500000  , 0,0,0)
  end
  if(armyexist("ARMY_7") == true) then
	CreateUnitHPR( tent, "ARMY_7", 75.500000, 25.992188, 142.500000  , 0,0,0)
	CreateUnitHPR( tent, "ARMY_7", 75.500000, 25.992188, 140.500000  , 0,0,0) 
	CreateUnitHPR( tent, "ARMY_7", 75.500000, 25.992188, 138.500000  , 0,0,0)
  end
  if(armyexist("ARMY_8") == true) then
	CreateUnitHPR( tent, "ARMY_8", 64.500000, 25.984375, 200.500000 , 0,0,0)
	CreateUnitHPR( tent, "ARMY_8", 64.500000, 25.984375, 198.500000 , 0,0,0)
	CreateUnitHPR( tent, "ARMY_8", 64.500000, 25.984375, 196.500000 , 0,0,0) 
  end
end	

if (ScenarioInfo.Options.opt_tents == 4) then
  if(armyexist("ARMY_1") == true) then
	CreateUnitHPR( tent, "ARMY_1", 309.500000, 25.984375, 445.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_1", 309.500000, 25.984375, 443.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_1", 309.500000, 25.984375, 441.500000, 0,0,0) 
	CreateUnitHPR( tent, "ARMY_1", 307.500000, 25.984375, 445.500000, 0,0,0)
  end
  if(armyexist("ARMY_2") == true) then
	CreateUnitHPR( tent, "ARMY_2", 371.500000, 25.984375, 429.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_2", 371.500000, 25.984375, 427.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_2", 371.500000, 25.984375, 425.500000, 0,0,0) 
	CreateUnitHPR( tent, "ARMY_2", 373.500000, 25.984375, 429.500000, 0,0,0)
  end
  if(armyexist("ARMY_3") == true) then
	CreateUnitHPR( tent, "ARMY_3", 431.500000, 25.984375, 367.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_3", 431.500000, 25.984375, 369.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_3", 431.500000, 25.984375, 365.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_3", 433.500000, 25.984375, 369.500000, 0,0,0)   
  end
  if(armyexist("ARMY_4") == true) then	
	CreateUnitHPR( tent, "ARMY_4", 447.500000, 25.984375, 315.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_4", 447.500000, 25.984375, 313.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_4", 447.500000, 25.984375, 311.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_4", 449.500000, 25.984375, 315.500000, 0,0,0)
  end
  if(armyexist("ARMY_5") == true) then
	CreateUnitHPR( tent, "ARMY_5", 202.500000, 25.984375, 70.500000 , 0,0,0)
	CreateUnitHPR( tent, "ARMY_5", 202.500000, 25.984375, 68.500000 , 0,0,0)
	CreateUnitHPR( tent, "ARMY_5", 202.500000, 25.984375, 66.500000 , 0,0,0) 
	CreateUnitHPR( tent, "ARMY_5", 204.500000, 25.984375, 70.500000 , 0,0,0)
  end
  if(armyexist("ARMY_6") == true) then
	CreateUnitHPR( tent, "ARMY_6", 136.500000, 25.992188, 81.500000  , 0,0,0)
	CreateUnitHPR( tent, "ARMY_6", 136.500000, 25.992188, 79.500000  , 0,0,0)
	CreateUnitHPR( tent, "ARMY_6", 136.500000, 25.992188, 77.500000  , 0,0,0)
	CreateUnitHPR( tent, "ARMY_6", 134.500000, 25.992188, 81.500000  , 0,0,0)  
  end
  if(armyexist("ARMY_7") == true) then
	CreateUnitHPR( tent, "ARMY_7", 75.500000, 25.992188, 142.500000  , 0,0,0)
	CreateUnitHPR( tent, "ARMY_7", 75.500000, 25.992188, 140.500000  , 0,0,0) 
	CreateUnitHPR( tent, "ARMY_7", 75.500000, 25.992188, 138.500000  , 0,0,0)
	CreateUnitHPR( tent, "ARMY_7", 73.500000, 25.992188, 142.500000  , 0,0,0)
  end
  if(armyexist("ARMY_8") == true) then
	CreateUnitHPR( tent, "ARMY_8", 64.500000, 25.984375, 200.500000 , 0,0,0)
	CreateUnitHPR( tent, "ARMY_8", 64.500000, 25.984375, 198.500000 , 0,0,0)
	CreateUnitHPR( tent, "ARMY_8", 64.500000, 25.984375, 196.500000 , 0,0,0) 
	CreateUnitHPR( tent, "ARMY_8", 62.500000, 25.984375, 200.500000 , 0,0,0) 
  end
end	

if (ScenarioInfo.Options.opt_tents == 5) then
  if(armyexist("ARMY_1") == true) then
	CreateUnitHPR( tent, "ARMY_1", 309.500000, 25.984375, 445.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_1", 309.500000, 25.984375, 443.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_1", 309.500000, 25.984375, 441.500000, 0,0,0) 
	CreateUnitHPR( tent, "ARMY_1", 307.500000, 25.984375, 445.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_1", 307.500000, 25.984375, 443.500000, 0,0,0)
  end
  if(armyexist("ARMY_2") == true) then
	CreateUnitHPR( tent, "ARMY_2", 371.500000, 25.984375, 429.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_2", 371.500000, 25.984375, 427.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_2", 371.500000, 25.984375, 425.500000, 0,0,0) 
	CreateUnitHPR( tent, "ARMY_2", 373.500000, 25.984375, 429.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_2", 373.500000, 25.984375, 427.500000, 0,0,0)
  end
  if(armyexist("ARMY_3") == true) then
	CreateUnitHPR( tent, "ARMY_3", 431.500000, 25.984375, 367.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_3", 431.500000, 25.984375, 369.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_3", 431.500000, 25.984375, 365.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_3", 433.500000, 25.984375, 369.500000, 0,0,0)  
	CreateUnitHPR( tent, "ARMY_3", 433.500000, 25.984375, 367.500000, 0,0,0)
  end
  if(armyexist("ARMY_4") == true) then
	CreateUnitHPR( tent, "ARMY_4", 447.500000, 25.984375, 315.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_4", 447.500000, 25.984375, 313.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_4", 447.500000, 25.984375, 311.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_4", 449.500000, 25.984375, 315.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_4", 449.500000, 25.984375, 313.500000, 0,0,0)
  end
  if(armyexist("ARMY_5") == true) then
	CreateUnitHPR( tent, "ARMY_5", 202.500000, 25.984375, 70.500000 , 0,0,0)
	CreateUnitHPR( tent, "ARMY_5", 202.500000, 25.984375, 68.500000 , 0,0,0)
	CreateUnitHPR( tent, "ARMY_5", 202.500000, 25.984375, 66.500000 , 0,0,0) 
	CreateUnitHPR( tent, "ARMY_5", 204.500000, 25.984375, 70.500000 , 0,0,0)
	CreateUnitHPR( tent, "ARMY_5", 204.500000, 25.984375, 68.500000 , 0,0,0)
  end
  if(armyexist("ARMY_6") == true) then
	CreateUnitHPR( tent, "ARMY_6", 136.500000, 25.992188, 81.500000  , 0,0,0)
	CreateUnitHPR( tent, "ARMY_6", 136.500000, 25.992188, 79.500000  , 0,0,0)
	CreateUnitHPR( tent, "ARMY_6", 136.500000, 25.992188, 77.500000  , 0,0,0)
	CreateUnitHPR( tent, "ARMY_6", 134.500000, 25.992188, 81.500000  , 0,0,0) 
    CreateUnitHPR( tent, "ARMY_6", 134.500000, 25.992188, 79.500000  , 0,0,0) 
  end
  if(armyexist("ARMY_7") == true) then
	CreateUnitHPR( tent, "ARMY_7", 75.500000, 25.992188, 142.500000  , 0,0,0)
	CreateUnitHPR( tent, "ARMY_7", 75.500000, 25.992188, 140.500000  , 0,0,0) 
	CreateUnitHPR( tent, "ARMY_7", 75.500000, 25.992188, 138.500000  , 0,0,0)
	CreateUnitHPR( tent, "ARMY_7", 73.500000, 25.992188, 142.500000  , 0,0,0)
	CreateUnitHPR( tent, "ARMY_7", 73.500000, 25.992188, 140.500000  , 0,0,0) 
  end
  if(armyexist("ARMY_8") == true) then
	CreateUnitHPR( tent, "ARMY_8", 64.500000, 25.984375, 200.500000 , 0,0,0)
	CreateUnitHPR( tent, "ARMY_8", 64.500000, 25.984375, 198.500000 , 0,0,0)
	CreateUnitHPR( tent, "ARMY_8", 64.500000, 25.984375, 196.500000 , 0,0,0) 
	CreateUnitHPR( tent, "ARMY_8", 62.500000, 25.984375, 200.500000 , 0,0,0) 
	CreateUnitHPR( tent, "ARMY_8", 62.500000, 25.984375, 198.500000 , 0,0,0)
  end
end

if (ScenarioInfo.Options.opt_tents == 6) then
  if(armyexist("ARMY_1") == true) then
	CreateUnitHPR( tent, "ARMY_1", 309.500000, 25.984375, 445.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_1", 309.500000, 25.984375, 443.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_1", 309.500000, 25.984375, 441.500000, 0,0,0) 
	CreateUnitHPR( tent, "ARMY_1", 307.500000, 25.984375, 445.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_1", 307.500000, 25.984375, 443.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_1", 307.500000, 25.984375, 441.500000, 0,0,0)
  end
  if(armyexist("ARMY_2") == true) then
	CreateUnitHPR( tent, "ARMY_2", 371.500000, 25.984375, 429.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_2", 371.500000, 25.984375, 427.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_2", 371.500000, 25.984375, 425.500000, 0,0,0) 
	CreateUnitHPR( tent, "ARMY_2", 373.500000, 25.984375, 429.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_2", 373.500000, 25.984375, 427.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_2", 373.500000, 25.984375, 425.500000, 0,0,0)
  end
  if(armyexist("ARMY_3") == true) then
	CreateUnitHPR( tent, "ARMY_3", 431.500000, 25.984375, 367.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_3", 431.500000, 25.984375, 369.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_3", 431.500000, 25.984375, 365.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_3", 433.500000, 25.984375, 369.500000, 0,0,0)  
	CreateUnitHPR( tent, "ARMY_3", 433.500000, 25.984375, 367.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_3", 433.500000, 25.984375, 365.500000, 0,0,0)
  end
  if(armyexist("ARMY_4") == true) then
	CreateUnitHPR( tent, "ARMY_4", 447.500000, 25.984375, 315.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_4", 447.500000, 25.984375, 313.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_4", 447.500000, 25.984375, 311.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_4", 449.500000, 25.984375, 315.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_4", 449.500000, 25.984375, 313.500000, 0,0,0)
	CreateUnitHPR( tent, "ARMY_4", 449.500000, 25.984375, 311.500000, 0,0,0) 
  end
  if(armyexist("ARMY_5") == true) then
	CreateUnitHPR( tent, "ARMY_5", 202.500000, 25.984375, 70.500000 , 0,0,0)
	CreateUnitHPR( tent, "ARMY_5", 202.500000, 25.984375, 68.500000 , 0,0,0)
	CreateUnitHPR( tent, "ARMY_5", 202.500000, 25.984375, 66.500000 , 0,0,0) 
	CreateUnitHPR( tent, "ARMY_5", 204.500000, 25.984375, 70.500000 , 0,0,0)
	CreateUnitHPR( tent, "ARMY_5", 204.500000, 25.984375, 68.500000 , 0,0,0)
    CreateUnitHPR( tent, "ARMY_5", 204.500000, 25.984375, 66.500000 , 0,0,0)
  end
  if(armyexist("ARMY_6") == true) then
	CreateUnitHPR( tent, "ARMY_6", 136.500000, 25.992188, 81.500000  , 0,0,0)
	CreateUnitHPR( tent, "ARMY_6", 136.500000, 25.992188, 79.500000  , 0,0,0)
	CreateUnitHPR( tent, "ARMY_6", 136.500000, 25.992188, 77.500000  , 0,0,0)
	CreateUnitHPR( tent, "ARMY_6", 134.500000, 25.992188, 81.500000  , 0,0,0) 
    CreateUnitHPR( tent, "ARMY_6", 134.500000, 25.992188, 79.500000  , 0,0,0) 
    CreateUnitHPR( tent, "ARMY_6", 134.500000, 25.992188, 77.500000  , 0,0,0)
  end
  if(armyexist("ARMY_7") == true) then
	CreateUnitHPR( tent, "ARMY_7", 75.500000, 25.992188, 142.500000  , 0,0,0)
	CreateUnitHPR( tent, "ARMY_7", 75.500000, 25.992188, 140.500000  , 0,0,0) 
	CreateUnitHPR( tent, "ARMY_7", 75.500000, 25.992188, 138.500000  , 0,0,0)
	CreateUnitHPR( tent, "ARMY_7", 73.500000, 25.992188, 142.500000  , 0,0,0)
	CreateUnitHPR( tent, "ARMY_7", 73.500000, 25.992188, 140.500000  , 0,0,0)
    CreateUnitHPR( tent, "ARMY_7", 73.500000, 25.992188, 138.500000  , 0,0,0)  
  end
  if(armyexist("ARMY_8") == true) then
	CreateUnitHPR( tent, "ARMY_8", 64.500000, 25.984375, 200.500000 , 0,0,0)
	CreateUnitHPR( tent, "ARMY_8", 64.500000, 25.984375, 198.500000 , 0,0,0)
	CreateUnitHPR( tent, "ARMY_8", 64.500000, 25.984375, 196.500000 , 0,0,0) 
	CreateUnitHPR( tent, "ARMY_8", 62.500000, 25.984375, 200.500000 , 0,0,0) 
	CreateUnitHPR( tent, "ARMY_8", 62.500000, 25.984375, 198.500000 , 0,0,0)
	CreateUnitHPR( tent, "ARMY_8", 62.500000, 25.984375, 196.500000 , 0,0,0)
  end
end
end

--given a player returns a proper username
getUsername = function(army)
	return GetArmyBrain(army).Nickname;
end

transportscoutonly = function()
if (ScenarioInfo.Options.opt_transcount == 1) then
	local tblArmies = ListArmies() 
        for index, name in tblArmies do 
            AddBuildRestriction(index, categories.uea0103) --UEF T1 Attack Bomber: Scorcher
			AddBuildRestriction(index, categories.uea0102) --UEF T1 Interceptor: Cyclone
			AddBuildRestriction(index, categories.dea0202) --UEF T2 Fighter/Bomber: Janus
			AddBuildRestriction(index, categories.uea0203) --UEF T2 Gunship: Stinger
			AddBuildRestriction(index, categories.uea0204) --UEF T2 Torpedo Bomber: Stork
			AddBuildRestriction(index, categories.uea0304) --UEF T3 Strategic Bomber: Ambassador
			AddBuildRestriction(index, categories.uea0305) --UEF T3 Heavy Gunship: Broadsword
			AddBuildRestriction(index, categories.uea0303) --UEF T3 Air-Superiority Fighter: Wasp
			
			AddBuildRestriction(index, categories.xsa0103) --Seraphim T1 Attack Bomber: Sinnve
			AddBuildRestriction(index, categories.xsa0102) --Seraphim T1 Interceptor: Ia-atha
			AddBuildRestriction(index, categories.xsa0202) --Seraphim T2 Fighter/Bomber: Notha
			AddBuildRestriction(index, categories.xsa0203) --Seraphim T2 Gunship: Vulthoo
			AddBuildRestriction(index, categories.xsa0204) --Seraphim T2 Torpedo Bomber: Uosioz
			AddBuildRestriction(index, categories.xsa0303) --Seraphim T3 Air-Superiority Fighter: Iazyne
			AddBuildRestriction(index, categories.xsa0304) --Seraphim T3 Strategic Bomber: Sinntha
			
			AddBuildRestriction(index, categories.ura0103) --Cybran T1 Attack Bomber: Zeus
			AddBuildRestriction(index, categories.ura0102) --Cybran T1 Interceptor: Prowler
			AddBuildRestriction(index, categories.xra0105) --Cybran T1 Light Gunship: Jester
			AddBuildRestriction(index, categories.dra0202) --Cybran T2 Fighter/Bomber: Corsair
			AddBuildRestriction(index, categories.ura0203) --Cybran T2 Gunship: Renegade
			AddBuildRestriction(index, categories.ura0204) --Cybran T2 Torpedo Bomber: Cormorant
			AddBuildRestriction(index, categories.ura0303) --Cybran T3 Air Superiority Fighter: Gemini
			AddBuildRestriction(index, categories.xra0305) --Cybran T3 Heavy Gunship: Wailer
			AddBuildRestriction(index, categories.ura0304) --Cybran T3 Strategic Bomber: Revenant
			
			AddBuildRestriction(index, categories.uaa0103) --Aeon T1 Attack Bomber: Shimmer
			AddBuildRestriction(index, categories.uaa0102) --Aeon T1 Interceptor: Conservator
			AddBuildRestriction(index, categories.xaa0202) --Aeon T2 Combat Fighter: Swift Wind
			AddBuildRestriction(index, categories.daa0206) --Aeon T2 Guided Missile: Mercy
			AddBuildRestriction(index, categories.uaa0203) --Aeon T2 Gunship: Specter
			AddBuildRestriction(index, categories.uaa0204) --Aeon T2 Torpedo Bomber: Skimmer
			AddBuildRestriction(index, categories.xaa0305) --Aeon T3 AA Gunship: Restorer
			AddBuildRestriction(index, categories.uaa0303) --Aeon T3 Air-Superiority Fighter: Corona
			AddBuildRestriction(index, categories.uaa0304) --Aeon T3 Strategic Bomber: Shocker
			AddBuildRestriction(index, categories.xaa0306) --Aeon T3 Torpedo Bomber: Solace
        end
	end	
end


unlockovertime = function()
if (ScenarioInfo.Options.opt_timeunlocked == 0) then
        LOG("Skipping")
	else
		local tblArmies = ListArmies() 
        for index, name in tblArmies do 
            AddBuildRestriction(index, categories.TECH3)
			AddBuildRestriction(index, categories.TECH2)
			AddBuildRestriction(index, categories.EXPERIMENTAL)
		end
	
		ForkThread(enableT2)
		ForkThread(enableT3)
		ForkThread(enableEXP)
	end
end

enableT2 = function()
    getunlocktime = unlockwait()
    LOG("Waiting for T2 - ", getunlocktime)
    WaitSeconds(getunlocktime)
    local tblArmies = ListArmies() 
        for index, name in tblArmies do 
            RemoveBuildRestriction(index, categories.TECH2)
		end
		transportscoutonly()
	PrintText("Tech 2 Enabled", 20, "ffffffff", 5, 'center');
end	

enableT3 = function()
	getunlocktime = unlockwait()	
    LOG("Waiting for t3 - ", getunlocktime * 2)
    WaitSeconds(getunlocktime * 2)
    local tblArmies = ListArmies() 
        for index, name in tblArmies do 
            RemoveBuildRestriction(index, categories.TECH3)
		end
	transportscoutonly()
	PrintText("Tech 3 Enabled", 20, "ffffffff", 5, 'center');
end	

enableEXP = function()
	getunlocktime = unlockwait()	
    LOG("Waiting for t4 - ", getunlocktime * 3)
    WaitSeconds(getunlocktime * 3)
    local tblArmies = ListArmies() 
        for index, name in tblArmies do 
            RemoveBuildRestriction(index, categories.EXPERIMENTAL)
		end
	transportscoutonly()
	PrintText("Experimentals Enabled", 20, "ffffffff", 5, 'center');
end	

unlockwait = function()
	if (ScenarioInfo.Options.opt_timeunlocked == 1) then
		return 60 * 5
    end
	if (ScenarioInfo.Options.opt_timeunlocked == 2) then
		return 60 * 10
	end
	if (ScenarioInfo.Options.opt_timeunlocked == 3) then
		return 60 * 15
	end
	if (ScenarioInfo.Options.opt_timeunlocked == 4) then
		return 60 * 20
	end
end

--countDown = function(timeseconds) 
--   for timeleft = timeseconds,0,-1 do 
--      Sync.ObjectiveTimer = timeleft 
--      WaitSeconds(1) 
--   end 
--end 

createmiddleciv = function()
    if (ScenarioInfo.Options.opt_gamemode == 1) then
		local T2DefenceCount = 0
		local T1DefenceCount = 0
		local T3DefenceAACount = 0
		local T3DefenceShieldCount = 0
		local T3PowerCount = 0
		
       --uab1301 AEON T3 POWER
	   --uab2301 AEON T2 PD
	   --uab2101 AEON T1 PD
	   --uab4301 AEON T3 shield
	   --uac1901 paragon activator
	   --ueb2304 aeon t3 aa
	   --uab3104 aeon t3 radar
	
		while T2DefenceCount < Random(8,16) do
			CreateUnitHPR("uab2301", "NEUTRAL_CIVILIAN", Random(230,280), 25.984375, Random(230,280), 0,0,0) --T2 PD 
		    T2DefenceCount = T2DefenceCount + 1
		end
		while T1DefenceCount < Random(8,16) do	
			CreateUnitHPR("uab2101", "NEUTRAL_CIVILIAN", Random(230,280), 25.984375, Random(230,280), 0,0,0) --T1 PD
		    T1DefenceCount = T1DefenceCount + 1
		end
		while T3DefenceAACount < Random(8,16) do	
			CreateUnitHPR("ueb2304", "NEUTRAL_CIVILIAN", Random(230,280), 25.984375, Random(230,280), 0,0,0) --T3 Anti Air 
		    T3DefenceAACount = T3DefenceAACount + 1
		end
		while T3DefenceShieldCount < Random(2,4) do	
			CreateUnitHPR("uab4301", "NEUTRAL_CIVILIAN", Random(230,280), 25.984375, Random(230,280), 0,0,0) --T3 Shield 
		    T3DefenceShieldCount = T3DefenceShieldCount + 1
		end
		while T3PowerCount < Random(2,4) do	
			CreateUnitHPR("uab1301", "NEUTRAL_CIVILIAN", Random(230,280), 25.984375, Random(230,280), 0,0,0)  --T3 Power
		    T3PowerCount = T3PowerCount + 1
		end
		CreateUnitHPR("uab3104", "NEUTRAL_CIVILIAN", Random(230,280), 25.984375, Random(230,280), 0,0,0) --Radar
		
		local paraactivator = CreateUnitHPR("uac1901", "NEUTRAL_CIVILIAN", Random(245,265), 25.984375, Random(245,265), 0,0,0) --Paragon Activator			
		paraactivator:SetReclaimable(false);
        paraactivator:SetCanTakeDamage(false);
		
		paraactivator.OldOnCaptured = paraactivator.OnCaptured;
	 
	    paraactivator.OnCaptured = function(self, captor)	
			local newunit = ChangeUnitArmy(self,captor:GetArmy())
			ForkThread(createparagon,captor:GetArmy())
		end
		if(armyexist("ARMY_1") == true) then
			SetAlliance("NEUTRAL_CIVILIAN","ARMY_1","Enemy")
		end
		if(armyexist("ARMY_2") == true) then
			SetAlliance("NEUTRAL_CIVILIAN","ARMY_2","Enemy")
		end
		if(armyexist("ARMY_3") == true) then
			SetAlliance("NEUTRAL_CIVILIAN","ARMY_3","Enemy")
		end
		if(armyexist("ARMY_4") == true) then
		 SetAlliance("NEUTRAL_CIVILIAN","ARMY_4","Enemy")
		end
		if(armyexist("ARMY_5") == true) then
		 SetAlliance("NEUTRAL_CIVILIAN","ARMY_5","Enemy")
		end
		if(armyexist("ARMY_6") == true) then
		 SetAlliance("NEUTRAL_CIVILIAN","ARMY_6","Enemy")
		end
		if(armyexist("ARMY_7") == true) then
		 SetAlliance("NEUTRAL_CIVILIAN","ARMY_7","Enemy")
		end
		if(armyexist("ARMY_8") == true) then
		 SetAlliance("NEUTRAL_CIVILIAN","ARMY_8","Enemy")
		end
	end
end

createparagon = function(paragonarmy)
	if paragonarmy == 1 then
		local thetemppara = CreateUnitHPR("xab1401", "ARMY_1", Random(312,492), 25.984375, Random(312,492), 0,0,0)   --army 1-4
		thetemppara:CreateProjectile( '/effects/entities/UnitTeleport01/UnitTeleport01_proj.bp', 0, 1.35, 0, nil, nil, nil):SetCollision(false)
		thetemppara.OnCaptured = function(self, captor)
		end
		ForkThread(paragontimer,thetemppara,"ARMY_1")
	elseif paragonarmy == 2 then
		local thetemppara = CreateUnitHPR("xab1401", "ARMY_2", Random(312,492), 25.984375, Random(312,492), 0,0,0)   --army 1-4
		thetemppara:CreateProjectile( '/effects/entities/UnitTeleport01/UnitTeleport01_proj.bp', 0, 1.35, 0, nil, nil, nil):SetCollision(false)
		thetemppara.OnCaptured = function(self, captor)
		end
		ForkThread(paragontimer,thetemppara,"ARMY_2")
	elseif paragonarmy == 3 then
		local thetemppara = CreateUnitHPR("xab1401", "ARMY_3", Random(312,492), 25.984375, Random(312,492), 0,0,0)   --army 1-4
		thetemppara:CreateProjectile( '/effects/entities/UnitTeleport01/UnitTeleport01_proj.bp', 0, 1.35, 0, nil, nil, nil):SetCollision(false)
		thetemppara.OnCaptured = function(self, captor)
		end
		ForkThread(paragontimer,thetemppara,"ARMY_3")
	elseif paragonarmy == 4 then
		local thetemppara = CreateUnitHPR("xab1401", "ARMY_4", Random(312,492), 25.984375, Random(312,492), 0,0,0)   --army 1-4
		thetemppara:CreateProjectile( '/effects/entities/UnitTeleport01/UnitTeleport01_proj.bp', 0, 1.35, 0, nil, nil, nil):SetCollision(false)
		thetemppara.OnCaptured = function(self, captor)
		end
		ForkThread(paragontimer,thetemppara,"ARMY_4")
	elseif paragonarmy == 5 then
		local thetemppara = CreateUnitHPR("xab1401", "ARMY_5", Random(20,200), 25.984375, Random(20,200), 0,0,0)   --arny 5-8
		thetemppara:CreateProjectile( '/effects/entities/UnitTeleport01/UnitTeleport01_proj.bp', 0, 1.35, 0, nil, nil, nil):SetCollision(false)
		thetemppara.OnCaptured = function(self, captor)
		end
		ForkThread(paragontimer,thetemppara,"ARMY_5")
	elseif paragonarmy == 6 then
		local thetemppara = CreateUnitHPR("xab1401", "ARMY_6", Random(20,200), 25.984375, Random(20,200), 0,0,0)   --arny 5-8
		thetemppara:CreateProjectile( '/effects/entities/UnitTeleport01/UnitTeleport01_proj.bp', 0, 1.35, 0, nil, nil, nil):SetCollision(false)
		thetemppara.OnCaptured = function(self, captor)
		end
		ForkThread(paragontimer,thetemppara,"ARMY_6")
	elseif paragonarmy == 7 then
		local thetemppara = CreateUnitHPR("xab1401", "ARMY_7", Random(20,200), 25.984375, Random(20,200), 0,0,0)   --arny 5-8
		thetemppara:CreateProjectile( '/effects/entities/UnitTeleport01/UnitTeleport01_proj.bp', 0, 1.35, 0, nil, nil, nil):SetCollision(false)
		thetemppara.OnCaptured = function(self, captor)
		end
		ForkThread(paragontimer,thetemppara,"ARMY_7")
	elseif paragonarmy == 8 then
		local thetemppara = CreateUnitHPR("xab1401", "ARMY_8", Random(20,200), 25.984375, Random(20,200), 0,0,0)   --arny 5-8
		thetemppara:CreateProjectile( '/effects/entities/UnitTeleport01/UnitTeleport01_proj.bp', 0, 1.35, 0, nil, nil, nil):SetCollision(false)
		thetemppara.OnCaptured = function(self, captor)
		end
		ForkThread(paragontimer,thetemppara,"ARMY_8")
	else
		LOG("WTF")
	end
end

paragontimer = function(paraunit,paraowner)
	local paraname = getUsername(paraowner)
	PrintText(paraname .. " has a Paragon for 60 Seconds", 20, "ffffffff", 5, 'center');
	
	WaitSeconds(60)
	paraunit:Destroy()
	PrintText("Paragon Removed", 20, "ffffffff", 5, 'center');
	
	ForkThread(DestroyMid)
	WaitSeconds(10)
end

DestroyMid = function()
PrintText("Clearing Mid in 10 Seconds. Please clear the area.", 20, "ffffffff", 5, 'center');
WaitSeconds(10)

local ExplosionCount = 0
while ExplosionCount< Random(10,20) do
			local killit = CreateUnitHPR("ual0001", "NEUTRAL_CIVILIAN", Random(230,280), 25.984375, Random(230,280), 0,0,0) 
		    killit:Kill()
			--Kill(instigator,type,excessDamageRatio)
			WaitSeconds(Random(1,3))
			ExplosionCount = ExplosionCount + 1
		end
LOG("Boom")
WaitSeconds(5)
createmiddleciv()
end



